# Interface ICefRequest

Description
Hierarchy
Fields
Methods
Properties

## Unit

uCEFInterfaces

## Declaration

`type ICefRequest = interface(ICefBaseRefCounted)`

## Description

Interface used to represent a web request. The functions of this interface may be called on any thread.

UNKNOWN

<see href="https://bitbucket.org/chromiumembedded/cef/src/master/include/capi/cef_request_capi.h">CEF source file: /include/capi/cef_request_capi.h (cef_request_t))

## Hierarchy

- IInterface
- ICefBaseRefCounted
- ICefRequest

## Overview

### Methods

| `function IsReadOnly: Boolean;`
| `function GetUrl: ustring;`
| `procedure SetUrl(const value: ustring);`
| `function GetMethod: ustring;`
| `procedure SetMethod(const value: ustring);`
| `procedure SetReferrer(const referrerUrl: ustring; policy: TCefReferrerPolicy);`
| `function GetReferrerUrl: ustring;`
| `function GetReferrerPolicy: TCefReferrerPolicy;`
| `function GetPostData: ICefPostData;`
| `procedure SetPostData(const value: ICefPostData);`
| `procedure GetHeaderMap(const HeaderMap: ICefStringMultimap);`
| `procedure SetHeaderMap(const HeaderMap: ICefStringMultimap);`
| `function GetHeaderByName(const name: ustring): ustring;`
| `procedure SetHeaderByName(const name, value: ustring; overwrite: boolean);`
| `function GetFlags: TCefUrlRequestFlags;`
| `procedure SetFlags(flags: TCefUrlRequestFlags);`
| `function GetFirstPartyForCookies: ustring;`
| `procedure SetFirstPartyForCookies(const url: ustring);`
| `procedure Assign(const url, method: ustring; const postData: ICefPostData; const headerMap: ICefStringMultimap);`
| `function GetResourceType: TCefResourceType;`
| `function GetTransitionType: TCefTransitionType;`
| `function GetIdentifier: UInt64;`

### Properties

| `property Url : ustring read GetUrl write SetUrl;`
| `property Method : ustring read GetMethod write SetMethod;`
| `property ReferrerUrl : ustring read GetReferrerUrl;`
| `property ReferrerPolicy : TCefReferrerPolicy read GetReferrerPolicy;`
| `property PostData : ICefPostData read GetPostData write SetPostData;`
| `property Flags : TCefUrlRequestFlags read GetFlags write SetFlags;`
| `property FirstPartyForCookies : ustring read GetFirstPartyForCookies write SetFirstPartyForCookies;`
| `property ResourceType : TCefResourceType read GetResourceType;`
| `property TransitionType : TCefTransitionType read GetTransitionType;`
| `property Identifier : UInt64 read GetIdentifier;`

## Description

### Methods

| `function IsReadOnly: Boolean;`
Returns true (1) if this object is read-only. ###### Attributes GUID['{FB4718D3-7D13-4979-9F4C-D7F6C0EC592A}']

| `function GetUrl: ustring;`
Get the fully qualified URL.

| `procedure SetUrl(const value: ustring);`
Set the fully qualified URL.

| `function GetMethod: ustring;`
Get the request function type. The value will default to POST if post data is provided and GET otherwise.

| `procedure SetMethod(const value: ustring);`
Set the request function type.

| `procedure SetReferrer(const referrerUrl: ustring; policy: TCefReferrerPolicy);`
Set the referrer URL and policy. If non-NULL the referrer URL must be fully qualified with an HTTP or HTTPS scheme component. Any username, password or ref component will be removed.

| `function GetReferrerUrl: ustring;`
Get the referrer URL.

| `function GetReferrerPolicy: TCefReferrerPolicy;`
Get the referrer policy.

| `function GetPostData: ICefPostData;`
Get the post data.

| `procedure SetPostData(const value: ICefPostData);`
Set the post data.

| `procedure GetHeaderMap(const HeaderMap: ICefStringMultimap);`
Get the header values. Will not include the Referer value if any.

| `procedure SetHeaderMap(const HeaderMap: ICefStringMultimap);`
Set the header values. If a Referer value exists in the header map it will be removed and ignored.

| `function GetHeaderByName(const name: ustring): ustring;`
Returns the first header value for |name| or an NULL string if not found. Will not return the Referer value if any. Use GetHeaderMap instead if |name| might have multiple values.

| `procedure SetHeaderByName(const name, value: ustring; overwrite: boolean);`
Set the header |name| to |value|. If |overwrite| is true (1) any existing values will be replaced with the new value. If |overwrite| is false (0) any existing values will not be overwritten. The Referer value cannot be set using this function.

| `function GetFlags: TCefUrlRequestFlags;`
Get the flags used in combination with ICefUrlRequest. See TCefUrlRequestFlags for supported values.

| `procedure SetFlags(flags: TCefUrlRequestFlags);`
Set the flags used in combination with ICefUrlRequest. See TCefUrlRequestFlags for supported values.

| `function GetFirstPartyForCookies: ustring;`
Get the URL to the first party for cookies used in combination with ICefUrlRequest.

| `procedure SetFirstPartyForCookies(const url: ustring);`
Set the URL to the first party for cookies used in combination with ICefUrlRequest.

| `procedure Assign(const url, method: ustring; const postData: ICefPostData; const headerMap: ICefStringMultimap);`
Set all values at one time. This method corresponds to TCefRequest.set_ and cef_request_t.set

| `function GetResourceType: TCefResourceType;`
Get the resource type for this request. Only available in the browser process.

| `function GetTransitionType: TCefTransitionType;`
Get the transition type for this request. Only available in the browser process and only applies to requests that represent a main frame or sub- frame navigation.

| `function GetIdentifier: UInt64;`
Returns the globally unique identifier for this request or 0 if not specified. Can be used by ICefResourceRequestHandler implementations in the browser process to track a single request across multiple callbacks.

### Properties

| `property Url : ustring read GetUrl write SetUrl;`
Get the fully qualified URL.

| `property Method : ustring read GetMethod write SetMethod;`
Get the request function type. The value will default to POST if post data is provided and GET otherwise.

| `property ReferrerUrl : ustring read GetReferrerUrl;`
Get the referrer URL.

| `property ReferrerPolicy : TCefReferrerPolicy read GetReferrerPolicy;`
Get the referrer policy.

| `property PostData : ICefPostData read GetPostData write SetPostData;`
Get the post data.

| `property Flags : TCefUrlRequestFlags read GetFlags write SetFlags;`
Get the flags used in combination with ICefUrlRequest. See TCefUrlRequestFlags for supported values.

| `property FirstPartyForCookies : ustring read GetFirstPartyForCookies write SetFirstPartyForCookies;`
Get the URL to the first party for cookies used in combination with ICefUrlRequest.

| `property ResourceType : TCefResourceType read GetResourceType;`
Get the resource type for this request. Only available in the browser process.

| `property TransitionType : TCefTransitionType read GetTransitionType;`
Get the transition type for this request. Only available in the browser process and only applies to requests that represent a main frame or sub- frame navigation.

| `property Identifier : UInt64 read GetIdentifier;`
Returns the globally unique identifier for this request or 0 if not specified. Can be used by ICefResourceRequestHandler implementations in the browser process to track a single request across multiple callbacks.

Generated by PasDoc 0.16.0-snapshot.